//library inflection2.irregular_past_verbs;

/// A collection of verbs with irregular past.
final Map<String, String> irregularPastVerbs = const {
  "backslidden": "backslid",
  "forbidden": "forbade",
  "stridden": "strode",
  "stricken": "struck",
  "brought": "brought",
  "striven": "strove",
  "swollen": "swelled",
  "thought": "thought",
  "trodden": "trod",
  "forbade": "forbade",
  "arisen": "arose",
  "awoken": "awoke",
  "beaten": "beat",
  "became": "became",
  "become": "became",
  "bidden": "bid",
  "bitten": "bit",
  "broken": "broke",
  "bought": "bought",
  "caught": "caught",
  "choose": "chose",
  "chosen": "chose",
  "forbid": "forbade",
  "dreamt": "dreamt",
  "driven": "drove",
  "fallen": "fell",
  "fought": "fought",
  "freeze": "froze",
  "frozen": "froze",
  "gotten": "got",
  "ground": "ground",
  "hidden": "hid",
  "learnt": "learnt",
  "proven": "proved",
  "sought": "sought",
  "shaken": "shook",
  "shaven": "shaved",
  "shrank": "shrank",
  "shrink": "shrank",
  "shrunk": "shrank",
  "spoken": "spoke",
  "spoilt": "spoilt",
  "spread": "spread",
  "sprang": "sprang",
  "spring": "sprang",
  "sprung": "sprang",
  "stolen": "stole",
  "strewn": "strewed",
  "strode": "strode",
  "stride": "strode",
  "strike": "struck",
  "strove": "strove",
  "struck": "struck",
  "string": "strung",
  "strung": "strung",
  "taught": "taught",
  "thrown": "threw",
  "thrust": "thrust",
  "arise": "arose",
  "arose": "arose",
  "awake": "awoke",
  "awoke": "awoke",
  "borne": "bore",
  "began": "began",
  "begin": "began",
  "begun": "began",
  "bound": "bound",
  "bleed": "bled",
  "blown": "blew",
  "break": "broke",
  "breed": "bred",
  "bring": "brought",
  "broke": "broke",
  "build": "built",
  "built": "built",
  "burnt": "burnt",
  "catch": "caught",
  "chose": "chose",
  "cling": "clung",
  "clung": "clung",
  "creep": "crept",
  "crept": "crept",
  "dealt": "dealt",
  "wound": "wound",
  "wring": "wrung",
  "wrung": "wrung",
  "write": "wrote",
  "wrote": "wrote",
  "drawn": "drew",
  "drank": "drank",
  "drink": "drank",
  "drunk": "drank",
  "drive": "drove",
  "drove": "drove",
  "dwelt": "dwelt",
  "eaten": "ate",
  "fight": "fought",
  "found": "found",
  "fling": "flung",
  "flung": "flung",
  "flown": "flew",
  "froze": "froze",
  "given": "gave",
  "grind": "ground",
  "grown": "grew",
  "heard": "heard",
  "knelt": "knelt",
  "known": "knew",
  "leant": "leant",
  "leapt": "leapt",
  "leave": "left",
  "meant": "meant",
  "risen": "rose",
  "shake": "shook",
  "shorn": "sheared",
  "shone": "shone",
  "shook": "shook",
  "shoot": "shot",
  "shown": "showed",
  "slain": "slew",
  "sleep": "slept",
  "slept": "slept",
  "slide": "slid",
  "sling": "slung",
  "slung": "slung",
  "slunk": "slunk",
  "smelt": "smelt",
  "snuck": "snuck",
  "speak": "spoke",
  "spelt": "spelt",
  "spend": "spent",
  "spent": "spent",
  "spilt": "spilt",
  "split": "split",
  "spoke": "spoke",
  "stand": "stood",
  "stood": "stood",
  "steal": "stole",
  "stick": "stuck",
  "stole": "stole",
  "stuck": "stuck",
  "sting": "stung",
  "stung": "stung",
  "stank": "stank",
  "stink": "stank",
  "stunk": "stank",
  "swear": "swore",
  "swore": "swore",
  "sworn": "swore",
  "sweep": "swept",
  "swept": "swept",
  "swing": "swung",
  "swung": "swung",
  "taken": "took",
  "teach": "taught",
  "think": "thought",
  "threw": "threw",
  "throw": "threw",
  "tread": "trod",
  "wake": "woke",
  "woken": "woke",
  "woven": "wove",
  "bear": "bore",
  "bore": "bore",
  "born": "bore",
  "beat": "beat",
  "bend": "bent",
  "bent": "bent",
  "bind": "bound",
  "bite": "bit",
  "bled": "bled",
  "blew": "blew",
  "blow": "blew",
  "bred": "bred",
  "cast": "cast",
  "clad": "clad",
  "come": "came",
  "cost": "cost",
  "deal": "dealt",
  "does": "did",
  "done": "did",
  "draw": "drew",
  "drew": "drew",
  "fall": "fell",
  "feed": "fed",
  "feel": "felt",
  "fell": "fell",
  "felt": "felt",
  "find": "found",
  "flee": "fled",
  "fled": "fled",
  "flew": "flew",
  "gave": "gave",
  "give": "gave",
  "gone": "went",
  "grew": "grew",
  "grow": "grew",
  "hang": "hung",
  "hung": "hung",
  "have": "had",
  "hear": "heard",
  "hewn": "hewed",
  "hide": "hid",
  "hold": "held",
  "held": "held",
  "hurt": "hurt",
  "keep": "kept",
  "kept": "kept",
  "knew": "knew",
  "know": "knew",
  "laid": "laid",
  "lead": "led",
  "left": "left",
  "lend": "lent",
  "lent": "lent",
  "lain": "lay",
  "lose": "lost",
  "lost": "lost",
  "make": "made",
  "made": "made",
  "mean": "meant",
  "meet": "met",
  "mown": "mowed",
  "paid": "paid",
  "pled": "pled",
  "read": "read",
  "ride": "rode",
  "rode": "rode",
  "ring": "rang",
  "rung": "rang",
  "rise": "rose",
  "rose": "rose",
  "sang": "sang",
  "sawn": "sawed",
  "said": "said",
  "seen": "saw",
  "seek": "sought",
  "sell": "sold",
  "slew": "slew",
  "sold": "sold",
  "send": "sent",
  "sent": "sent",
  "sewn": "sewed",
  "shed": "shed",
  "shot": "shot",
  "shut": "shut",
  "sing": "sang",
  "sung": "sang",
  "slid": "slid",
  "slit": "slit",
  "sown": "sowed",
  "sped": "sped",
  "spin": "spun",
  "spun": "spun",
  "spit": "spit",
  "spat": "spat",
  "swam": "swam",
  "swim": "swam",
  "swum": "swam",
  "take": "took",
  "tear": "tore",
  "tore": "tore",
  "torn": "tore",
  "tell": "told",
  "told": "told",
  "took": "took",
  "trod": "trod",
  "wear": "wore",
  "wore": "wore",
  "worn": "wore",
  "weep": "wept",
  "went": "went",
  "wept": "wept",
  "were": "were",
  "wind": "wound",
  "woke": "woke",
  "wove": "wove",
  "are": "were",
  "ate": "ate",
  "bet": "bet",
  "bid": "bid",
  "bit": "bit",
  "buy": "bought",
  "cut": "cut",
  "did": "did",
  "dig": "dug",
  "dug": "dug",
  "eat": "ate",
  "fed": "fed",
  "fly": "flew",
  "get": "got",
  "got": "got",
  "had": "had",
  "has": "had",
  "hid": "hid",
  "hit": "hit",
  "lay": "laid",
  "led": "led",
  "let": "let",
  "lit": "lit",
  "met": "met",
  "pay": "paid",
  "put": "put",
  "ran": "ran",
  "rid": "rid",
  "run": "ran",
  "saw": "saw",
  "say": "said",
  "see": "saw",
  "sit": "sat",
  "sat": "sat",
  "set": "set",
  "was": "was",
  "win": "won",
  "won": "won",
  "do": "did",
  "go": "went",
  "is": "was",
};
